'use strict';

/* App Module */

var app = angular.module('app', [
    'ui.bootstrap',
    'ui.router',
    'LocalStorageModule',
    'ngMaterial',
    'ngMaterialDatePicker',
    'appSdk'
]);

app.config(['$stateProvider', '$urlRouterProvider', '$httpProvider', '$locationProvider',
    function($stateProvider, $urlRouterProvider, $httpProvider, $locationProvider) {

        //$locationProvider.html5Mode(true);

        $stateProvider.state('home',{
            url:'/',
            reloadOnSearch: false,
            templateUrl:'views/home.html',
            controller:'HomeController'
        });

        $stateProvider.state('freeroom',{
            url:'/freeroom',
            templateUrl:'views/freeroom.html',
            controller:'FreeRoomController'
        });

        $urlRouterProvider.otherwise('/');

    }])
    .directive('dateNow', ['$filter', function($filter) {
        return {
            link: function( $scope, $element, $attrs) {
                $element.text($filter('date')(new Date(), $attrs.dateNow));
            }
        };
    }])
    .run(['$rootScope', '$state', '$location', 'DataShareBusiness', 'GroupsBusiness', '$mdDateLocale', '$filter',
        function ($rootScope, $state, $location, DataShareBusiness, GroupsBusiness, $mdDateLocale, $filter) {

            $rootScope.$watch(function(){ return Object.keys($location.search())[0] }, function(){
                if (DataShareBusiness.Groups != null && $state.current.name == "home") {
                    DataShareBusiness.setFromSearchString(Object.keys($location.search())[0]);
                }
            });

            var promiseLoadGroups = {
                id: "promiseLoadGroups",
                loaderGroups: ["toolbar"],
                groups: ["sidebar"]
            };
            GroupsBusiness.loadAll(promiseLoadGroups).then(function(data)
            {
                if ($state.current.name == "home") {
                    DataShareBusiness.setFromSearchString(Object.keys($location.search())[0]);
                }
            });

            $mdDateLocale.firstDayOfWeek = 1;
            $mdDateLocale.formatDate = function(date) {
                return $filter("date")(date, DataShareBusiness.DateFormat);
            };
    }]);